#include <stdio.h>
#include "ptr.h"


typedef struct _FuncList {
    char name[32];
    struct _FuncList* next;
} FuncList;

FuncList list = {"", NULL};


void EnterFunc(char* name)
{
    FuncList* fl;
    fl=(FuncList*)malloc(sizeof(FuncList));
    strcpy(fl->name, name);
    fl->next=list.next;
    list.next=fl;
}
void LeaveFunc()
{
    FuncList* fl;
    fl=list.next;
    list.next=fl->next;
    free(fl);
}

char* FirstFunc()
{
    FuncList* fl;
    fl=&(list);
    while(fl->next) fl=fl->next;
    return fl->name;
}
char* LastFunc()
{
    if(list.next) return list.next->name;
    return NULL;
}

void SetError(int level, char* msg)
{
    char* last;  char* first;
    fprintf(stderr, "pointer library:\n");
    last=LastFunc();  first=FirstFunc();
    if(last==first){
        fprintf(stderr, " (in function \"%s\")\n", first);
    }else{
        fprintf(stderr, " (in function \"%s\",", last);
        fprintf(stderr, " called from \"%s\")\n", first);
    }
    switch(level){
      case INFO:
        fprintf(stderr, "Information: ");
        break;
      case WARN:
        fprintf(stderr, "Warning: ");
        break;
      case ERROR:
        fprintf(stderr, "Error: ");
        break;
      case FATAL:
        fprintf(stderr, "Fatal error: ");
        break;
      case INNER:
        fprintf(stderr, "Inner error: ");
        break;
    }
    fprintf(stderr, "%s\n", msg);
    if(level==FATAL) exit(1);
}
