#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/time.h>
#include <math.h>
#include "pgw.h"


FILE* psfp;

int psornt=LAND;
int pssize=A4;
int psgrayscale=FALSE;
char creator[MAX_STR]=PGWINDOW;
char psfname[MAX_STR]="none";
int pspage=0;


/* set postscript properties */

void SetPSOrientation(int val){
    psornt=val;
}
void SetPSPaperSize(int val){
    pssize=val;
}
void SetPSGrayScale(int val){
    psgrayscale=val;
}
void SetPSCreator(char* cr){
    strcpy(creator, cr);
}
int PSShort(){
    switch(pssize){
      case A3:
      case A5:
      case B4:
      case B5:
      default:
        return A4SHORT;
    }
}
int PSLong(){
    switch(pssize){
      case A3:
      case A5:
      case B4:
      case B5:
      default:
        return A4LONG;
    }
}
int PSSMargin(){
    return PSMARGIN*PSShort();
}
int PSLMargin(){
    return PSMARGIN*PSLong();
}
int PSWidth(){
    if(psornt==PORT){
        return PSShort()-2*PSSMargin();
    }else{
        return PSLong()-2*PSLMargin();
    }
}
int PSHeight(){
    if(psornt==PORT){
        return PSLong()-2*PSLMargin();
    }else{
        return PSShort()-2*PSSMargin();
    }
}



/* make header comments */

char* TimeStamp()
{
    time_t t;
    time(&t);
    return ctime(&t);
}

void MakeHeader()
{
    fprintf(psfp, "%c!PS-Adobe-3.0 EPSF-3.0\n", 37);
    fprintf(psfp, "%c%cCreator: (%s)\n", 37, 37, creator);
    fprintf(psfp, "%c%cTitle: (%s)\n", 37, 37, psfname);
    fprintf(psfp, "%c%cCreationDate:", 37, 37);
    fprintf(psfp, " %s", TimeStamp());
    fprintf(psfp, "%c%cBoundingBox: 0 0 %d %d\n",
	    37, 37, PSShort(), PSLong());
    if(psornt==PORT){
	fprintf(psfp, "%c%cOrientation: Portrait\n", 37, 37);
    }else{
	fprintf(psfp, "%c%cOrientation: Landscape\n", 37, 37);
    }
    fprintf(psfp, "%c%cEndComments\n", 37, 37);
}

void MakeProlog()
{
    fprintf(psfp, "%c%cBeginProlog\n", 37, 37);
    fprintf(psfp, "/L {lineto} bind def");
    fprintf(psfp, " /M {moveto} bind def\n");
    fprintf(psfp, "/RL {rlineto} bind def");
    fprintf(psfp, " /RM {rmoveto} bind def\n");
    fprintf(psfp, "/CLW {currentlinewidth} bind def\n");
    fprintf(psfp, "/RGB {setrgbcolor} bind def");
    fprintf(psfp, " /HSB {sethsbcolor} bind def\n");
    fprintf(psfp, "%c%cEndProlog\n\n", 37, 37);
}


void PSSetForeground(PGColor pgc){
    if(psgrayscale){
        fprintf(psfp, "%-5.3lf setgray\n",
                (pgc.r+pgc.g+pgc.b)/(255.0*3.0));
    }else{
        fprintf(psfp, "%-5.3lf %-5.3lf %-5.3lf RGB\n",
                pgc.r/255.0, pgc.g/255.0, pgc.b/255.0);
    }
}

void PSSetPoint(int ptype, double rad)
{
    switch(ptype){
      case PTS:
        fprintf(psfp, "/PT {CLW 1.5 mul 0 360 arc fill} def\n");
        break;
      case FSQR:
        fprintf(psfp, "/PT {M %-5.2lf %-5.2lf RM %-5.2lf 0 RL",
                -0.5*rad*SQRTPI, -0.5*rad*SQRTPI, rad*SQRTPI);
        fprintf(psfp, " 0 %-5.2lf RL %-5.2lf 0 RL 0 %-5.2lf RL",
                rad*SQRTPI, -rad*SQRTPI, -rad*SQRTPI);
        fprintf(psfp, " closepath fill} def\n");
        break;
      case SQR:
        fprintf(psfp, "/PT {M %-5.2lf %-5.2lf RM %-5.2lf 0 RL",
                -0.5*rad*SQRTPI, -0.5*rad*SQRTPI, rad*SQRTPI);
        fprintf(psfp, " 0 %-5.2lf RL %-5.2lf 0 RL 0 %-5.2lf RL",
                rad*SQRTPI, -rad*SQRTPI, -rad*SQRTPI);
        fprintf(psfp, " closepath stroke} def\n");
        break;
      case FCIR:
        fprintf(psfp, "/PT {%-5.2lf 0 360 arc fill} def\n", rad);
        break;
      default:
        fprintf(psfp, "/PT {%-5.2lf 0 360 arc stroke} def\n", rad);
        break;
    }
}

void PSSetDash(int ltype)
{
    switch(ltype){
      case DOT:
        fprintf(psfp, "[CLW dup 5 mul]");
        break;
      case BRK:
        fprintf(psfp, "[CLW 8 mul dup]");
        break;
      default:
        fprintf(psfp, "[]");
    }
    fprintf(psfp, " 0 setdash\n");
}

void PSSetLineWidth(double width)
{
    if(width<=0.0) return;
    fprintf(psfp, "CLW %6.3lf mul setlinewidth\n", width);
}

void PSSetFont(double pt, int fmly, int sl)
{
    static char fontname[FMLY][SL][MAX_STR]=PSFONTNAMES;
    fprintf(psfp, "/%s findfont %6.3lf scalefont setfont\n",
            fontname[fmly][sl], pt);
}




/* print string */
/*
void PutPGString(PGWindow* pgw, char* string, int rot, double pt)
{
    int fmly, sl;
    int i=0;  int j=0;
    char str[MAX_STR];
    char buf[MAX_STR];
    strcpy(str, string);
    fmly=DefaultFontFamily();
    sl=DefaultSlant();
    PSSetFont(pt, fmly, sl);
    while(str[i] != '\0'){
        buf[j]=str[i];
        j++;  i++;
    }
    buf[j]='\0';
    fprintf(psfp, "(%s) show\n", buf);
}
*/

void DrawPSCharacters(int pre, char* str)
{
    int i;
    PGFontList fl;
    if(str[0]=='\0') return;
    fl=CurrentPGFont();
    PSSetFont(fl.pt, fl.fmly, fl.sl);
    fprintf(psfp, "0 %lf RM\n", fl.sub);
    fprintf(psfp, "(");
    for(i=0; str[i]!='\0'; i++){
        switch(str[i]){
          case 92:
            fprintf(psfp, "%c134", 92);
            break;
          case 40:
            fprintf(psfp, "%c050", 92);
            break;
          case 41:
            fprintf(psfp, "%c051", 92);
            break;
          default:
            fprintf(psfp, "%c", str[i]);
            break;
        }
    }
    fprintf(psfp, ")\n");
    if(pre){
        fprintf(psfp, "stringwidth pop wid add /wid exch def\n");
    }else{
        fprintf(psfp, "show\n");
    }
    fprintf(psfp, "0 %lf RM\n", -fl.sub);
}

void DrawPSPGString(PGWindow* pgw, char* string, int flush,
                    int rot, double pt)
{
    static int pre=FALSE;
    int i=0;  int j=0;
    char str[MAX_STR];
    char buf[MAX_STR];
    if(!pre){
        fprintf(psfp, "gsave\n");
        fprintf(psfp, "currentpoint translate\n");
        fprintf(psfp, "%d rotate\n", rot);
        PSSetDash(SOL);
    }else{
        fprintf(psfp, "/wid 0 def\n");
    }
    if(!pre && flush!=RIGHT){
        pre=TRUE;
        DrawPSPGString(pgw, string, flush, rot, pt);
        pre=FALSE;
        if(flush==CENTER){
            fprintf(psfp, "-0.5 wid mul 0 RM\n");
        }else if(flush==LEFT){
            fprintf(psfp, "-1 wid mul 0 RM\n");
        }
    }
    strcpy(str, string);
    PushPGFontList(pt, DefaultFontFamily(), DefaultSlant(), 0.0);
    while(str[i] != '\0'){
        switch(str[i]){
          case 123:
            buf[j]='\0';
            DrawPSCharacters(pre, buf);
            j=0;  i++;
            DuplicateFontList();
            break;
          case 125:
            buf[j]='\0';
            DrawPSCharacters(pre, buf);
            j=0;  i++;
            PopPGFontList();
            break;
          case 33:
          case 92:
            buf[j]='\0';
            DrawPSCharacters(pre, buf);
            j=0;  i++;
            if(!LabelCommand(str+i, &i)){
                buf[j]=str[i];  j++;  i++;
            }
          default:
            buf[j]=str[i];
            j++;  i++;
        }
    }
    buf[j]='\0';
    DrawPSCharacters(pre, buf);
    ClearFontList();
    if(!pre) fprintf(psfp, "grestore\n");
}





/* print graph objects */

void PrintPGPoints(PGWindow* pgw, PGPoints* pg,
                   double psx, double psy)
{
    int i;
    double* px;  double* py;
    px=(double*)malloc(pg->num*sizeof(double));
    py=(double*)malloc(pg->num*sizeof(double));
    if(!TransCoords(pgw, 'p', pg->x1, pg->x2, pg->x3,
                    px, py, pg->num)){
        free(px);  free(py);
        return;
    }
    fprintf(psfp, "gsave\n");
    PSSetForeground(pg->pgp.pgcl);
    PSSetDash(SOL);
    PSSetLineWidth(pg->pgp.width);
    PSSetPoint(pg->pgp.ptype, TransScale(psx, psy, pg->pgp.rad));
    fprintf(psfp, "newpath\n");
    for(i=0; i<pg->num; i++)
            fprintf(psfp, "  %-6.2lf %-6.2lf PT\n", px[i], py[i]);
    fprintf(psfp, "stroke\n");
    fprintf(psfp, "grestore\n");
    free(px);  free(py);
}

void PrintPGLine(PGWindow* pgw, PGLine* pg,
                 double psx, double psy)
{
    int i;
    double* px;  double* py;
    px=(double*)malloc(pg->num*sizeof(double));
    py=(double*)malloc(pg->num*sizeof(double));
    if(!TransCoords(pgw, 'p', pg->x1, pg->x2, pg->x3,
                    px, py, pg->num)){
        free(px);  free(py);
        return;
    }
    fprintf(psfp, "gsave\n");
    PSSetForeground(pg->pgp.pgcl);
    PSSetDash(pg->pgp.ltype);
    PSSetLineWidth(pg->pgp.width);
    fprintf(psfp, "newpath\n");
    fprintf(psfp, "  %-6.2lf %-6.2lf M\n", px[0], py[0]);
    for(i=1; i<pg->num; i++)
            fprintf(psfp, "  %-6.2lf %-6.2lf L\n", px[i], py[i]);
    fprintf(psfp, "stroke\n");
    fprintf(psfp, "grestore\n");
    free(px);  free(py);
}

void PrintPGString(PGWindow* pgw, PGString* pg,
                   double psx, double psy)
{
    double px, py, pt;
    if(!TransCoords(pgw, 'p', &(pg->x1), &(pg->x2), &(pg->x3),
                    &px, &py, 1))
            return;
    PSSetForeground(pg->pgp.pgcl);
    fprintf(psfp, "%-6.2lf %-6.2lf M\n", px, py);
    pt=TransScale(psx, psy, pg->pgp.pt);
    DrawPSPGString(pgw, pg->str, pg->pgp.flush, pg->pgp.rot, pt);
}

void PrintPGFixString(PGWindow* pgw, PGFixString* pg,
                      double psx, double psy)
{
    double px, py, pt;
    PSSetForeground(pg->pgp.pgcl);
    px=psx*pg->x;  py=psy*(1.0-pg->y);
    fprintf(psfp, "%-6.2lf %-6.2lf M\n", px, py);
    pt=TransScale(psx, psy, pg->pgp.pt);
    DrawPSPGString(pgw, pg->str, pg->pgp.flush, pg->pgp.rot, pt);
}

void PrintPGArrows(PGWindow* pgw, PGArrows* pg,
                   double psx, double psy)
{
    int i;
    double ex=pg->exp;
    double arrow=pg->pgp.arrow;  double angle=pg->pgp.angle;
    double a11, a12, a21, a22, vx, vy;
    double b11, b12, b21, b22;
    double* px1;  double* py1;  double* px2;  double* py2;
    px1=(double*)malloc(pg->num*sizeof(double));
    py1=(double*)malloc(pg->num*sizeof(double));
    px2=(double*)malloc(pg->num*sizeof(double));
    py2=(double*)malloc(pg->num*sizeof(double));
    if(!(TransCoords(pgw, 'p',
                     pg->x1, pg->x2, pg->x3, px1, py1, pg->num))
    || !(TransCoords(pgw, 'p',
                     pg->v1, pg->v2, pg->v3, px2, py2, pg->num))){
        free(px1);  free(py1);  free(px2);  free(py2);
        return;
    }
    a11=arrow*cos(angle);  a12=-arrow*sin(angle);
    a21=arrow*sin(angle);  a22= arrow*cos(angle);
    b11=arrow*cos(-angle); b12=-arrow*sin(-angle);
    b21=arrow*sin(-angle); b22= arrow*cos(-angle);
    fprintf(psfp, "gsave\n");
    PSSetForeground(pg->pgp.pgcl);
    PSSetDash(pg->pgp.ltype);
    PSSetLineWidth(pg->pgp.width);
    fprintf(psfp, "newpath\n");
    for(i=0; i<pg->num; i++){
        fprintf(psfp, "  %-6.2lf %-6.2lf M\n", px1[i], py1[i]);
        if(pg->exp<=0.0){
            double rad, vl;
            rad=TransScale(psx, psy, UNITARROW);
            vl=sqrt((px2[i]-px1[i])*(px2[i]-px1[i])
                    +(py2[i]-py1[i])*(py2[i]-py1[i]));
            ex=rad/vl;
        }
        px2[i]=px1[i]+ex*(px2[i]-px1[i]);
        py2[i]=py1[i]+ex*(py2[i]-py1[i]);
        fprintf(psfp, "  %-6.2lf %-6.2lf L\n", px2[i], py2[i]);
        vx=px1[i]-px2[i];  vy=py1[i]-py2[i];
        fprintf(psfp, "  %-6.2lf %-6.2lf M\n",
                px2[i]+a11*vx+a12*vy, py2[i]+a21*vx+a22*vy);
        fprintf(psfp, "  %-6.2lf %-6.2lf L\n", px2[i], py2[i]);
        fprintf(psfp, "  %-6.2lf %-6.2lf L\n",
                px2[i]+b11*vx+b12*vy, py2[i]+b21*vx+b22*vy);
    }
    fprintf(psfp, "stroke\n");
    fprintf(psfp, "grestore\n");
    free(px1);  free(py1);  free(px2);  free(py2);
}



/* print window */

void PrintPGWindow(PGWindow* pgw, double width, double height)
{
    PGWindowList* pgwl;
    PGObjectList* pgl;
    double zerox, zeroy, wid, hgt;
    double linewidth;
    fprintf(psfp, "gsave\n");
    linewidth=BaseLineWidth()*PSLINEWIDTH;
    if(linewidth<=0.0) linewidth=PSLINEWIDTH;
    wid=pgw->width*width;
    hgt=pgw->height*height;
    zerox=pgw->x*width;
    zeroy=(1.0-pgw->y)*height-hgt;
    fprintf(psfp, "%-6.2lf %-6.2lf translate\n", zerox, zeroy);
    fprintf(psfp, "%-6.2lf setlinewidth\n",
            TransScale(wid, hgt, linewidth));
    fprintf(psfp, "\nnewpath\n");
    fprintf(psfp, "  0       0       M\n");
    fprintf(psfp, "  %-7.2lf 0       RL\n", wid);
    fprintf(psfp, "  0       %-7.2lf RL\n", hgt);
    fprintf(psfp, "  %-7.2lf 0       RL\n",-wid);
    fprintf(psfp, "  0       %-7.2lf RL\n",-hgt);
    fprintf(psfp, "closepath\n");
    fprintf(psfp, "clip\n");
    fprintf(psfp, "newpath\n");
    AxisVector(pgw, 'p', wid, hgt);
    pgl=pgw->pgl.next;
    while(pgl){
        if(pgl->pg->type==PGPOINTS){
            PrintPGPoints(pgw, (PGPoints*)(pgl->pg), wid, hgt);
        }else if(pgl->pg->type==PGLINE){
            PrintPGLine(pgw, (PGLine*)(pgl->pg), wid, hgt);
        }else if(pgl->pg->type==PGSTRING){
            PrintPGString(pgw, (PGString*)(pgl->pg), wid, hgt);
        }else if(pgl->pg->type==PGFIXSTRING){
            PrintPGFixString(pgw, (PGFixString*)(pgl->pg),
                             wid, hgt);
        }else if(pgl->pg->type==PGARROWS){
            PrintPGArrows(pgw, (PGArrows*)(pgl->pg), wid, hgt);
        }
        pgl=pgl->next;
    }
    pgwl=pgw->pgwl.next;
    while(pgwl){
        PrintPGWindow(pgwl->pgw, wid, hgt);
        pgwl=pgwl->next;
    }
    fprintf(psfp, "grestore\n");
}

int PGPSOpen(char* fname)
{
    if(psfp!=NULL) fclose(psfp);
    if(!(psfp=fopen(fname, "w"))) return FALSE;
    strcpy(psfname, fname);
    pspage=1;
    return TRUE;
}

int PGPrint(PGWindow* pgw)
{
    PGWindowList* pgwl;
    if(psfp==NULL) return FALSE;
    if(pspage==1){
        MakeHeader();
        MakeProlog();
    }
    fprintf(psfp, "%c%cPage: %d %d\n", 37, 37, pspage, pspage);
    fprintf(psfp, "gsave\n");
    if(psornt==PORT){
        fprintf(psfp, "%d %d translate\n",
                PSSMargin(), PSLMargin());
    }else{
        fprintf(psfp, "%d 0 translate\n", PSShort());
        fprintf(psfp, "90 rotate\n");
        fprintf(psfp, "%d %d translate\n",
                PSLMargin(), PSSMargin());
    }
    pgwl=pgw->pgwl.next;
    while(pgwl){
        PrintPGWindow(pgwl->pgw, PSWidth(), PSHeight());
        pgwl=pgwl->next;
    }
    fprintf(psfp, "grestore\n");
    return TRUE;
}

int PGShowPage()
{
    if(psfp==NULL) return FALSE;
    fprintf(psfp, "showpage\n");
    pspage++;
    return TRUE;
}
